VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2310
   ClientLeft      =   1635
   ClientTop       =   1545
   ClientWidth     =   3375
   LinkTopic       =   "Form1"
   ScaleHeight     =   2310
   ScaleWidth      =   3375
   Begin VB.CommandButton CmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   1920
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox IterText 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Text            =   "10000"
      Top             =   240
      Width           =   855
   End
   Begin VB.Label SpecificLabel 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   1560
      TabIndex        =   8
      Top             =   1800
      Width           =   1000
   End
   Begin VB.Label ImplementsLabel 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   1560
      TabIndex        =   7
      Top             =   1440
      Width           =   1000
   End
   Begin VB.Label GenericLabel 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   1560
      TabIndex        =   6
      Top             =   1080
      Width           =   1000
   End
   Begin VB.Label Label1 
      Caption         =   "Specific Object"
      Height          =   195
      Index           =   3
      Left            =   240
      TabIndex        =   5
      Top             =   1800
      Width           =   1125
   End
   Begin VB.Label Label1 
      Caption         =   "Implements"
      Height          =   195
      Index           =   2
      Left            =   240
      TabIndex        =   4
      Top             =   1440
      Width           =   1125
   End
   Begin VB.Label Label1 
      Caption         =   "Generic Object"
      Height          =   195
      Index           =   1
      Left            =   240
      TabIndex        =   3
      Top             =   1080
      Width           =   1125
   End
   Begin VB.Label Label1 
      Caption         =   "Iterations"
      Height          =   195
      Index           =   0
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   645
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CmdGo_Click()
Dim i As Long
Dim max As Long
Dim start_time As Single
Dim generic_time As Single
Dim implements_time As Single
Dim specific_time As Single
Dim generic_object As Object
Dim specific_object As New SpecificClass
Dim implements_object As New ImplementorClass

    Set generic_object = New SpecificClass
    GenericLabel.Caption = ""
    ImplementsLabel.Caption = ""
    SpecificLabel.Caption = ""
    MousePointer = vbHourglass
    DoEvents

    ' Generic.
    max = CLng(IterText.Text)
    start_time = Timer
    For i = 1 To max
        generic_object.Value = 12345
    Next i
    generic_time = Timer - start_time
    GenericLabel.Caption = Format$(generic_time, "0.00")

    ' Implements.
    start_time = Timer
    For i = 1 To max
        implements_object.Value = 12345
    Next i
    implements_time = Timer - start_time
    ImplementsLabel.Caption = _
        Format$(implements_time, "0.00") & _
        " (" & _
        Format$(generic_time / implements_time, "0.0") & _
        " times as fast)"
    
    ' Specific.
    start_time = Timer
    For i = 1 To max
        specific_object.Value = 12345
    Next i
    specific_time = Timer - start_time
    SpecificLabel.Caption = _
        Format$(specific_time, "0.00") & _
        " (" & _
        Format$(generic_time / specific_time, "0.0") & _
        " times as fast)"
    
    MousePointer = vbDefault
End Sub


